chiark / gitweb /
xinitrc and friends: Embed prompt-and-run functionality in xinitrc.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
8ba15f37 13: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
852cd5fb 116echo " all done."
f617db13 117
ce178f96
MW
118###--------------------------------------------------------------------------
119### Install global configuration.
120
f141fe0f
MW
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
ce178f96 129## Symlink the various dotfiles into place
852cd5fb 130dotfiles="
be7dba95 131 bash_profile bash_logout bashrc inputrc bash_completion
b3468c3b 132 emacs emacs-calc vm
3e3c03ee 133 vimrc mg
b3468c3b 134 mailrc signature
ce178f96 135 cgrc tigrc
e7d23024 136 gdbinit
8a7e906d 137 guile
5d25e440 138 toprc
cbffcf2b 139 aspell.conf
ccaac00b
MW
140 lisp-init.lisp:.cmucl-init.lisp
141 lisp-init.lisp:.sbclrc
142 lisp-init.lisp:.clisprc.lisp
f6335a0c 143 lisp-init.lisp:.eclrc
2425eca9 144 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 145[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 146 xinitrc xsession Xdefaults vncrc vncsession
5e23020b 147 fonts.conf
1c6b19d4 148 putty-defaults:.putty/sessions/Default%20Settings
7cfa1f1a 149 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 150 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 151 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
eebca092
MW
152 e16-bindings:.e16/bindings.cfg
153 e16-config:.e16/e_config--1.0.cfg
154 jue-peek.jpg:.enlightenment/backgrounds/jue-peek.jpg
155 jue-peek.jpg:.e16/backgrounds/jue-peek.jpg"
f617db13
MW
156echo "Installing dotfiles..."
157for d in $dotfiles; do
739bccbf
MW
158 target=.$d
159 case $d in
160 *:*) target=${d#*:} d=${d%%:*};;
161 esac
162 ft=$HOME$sub/$target
163 dir=${ft%/*}
164 mkdir -p $dir
165 ln -s $here/$d $ft.new
166 mv $ft.new $ft
167 echo " $target"
f617db13 168done
852cd5fb 169echo " all done."
f617db13 170
ce178f96
MW
171###--------------------------------------------------------------------------
172### Process the Git configuration.
173
174echo -n "Installing Git configuration:"
175sed "
1761i\
15581433 177### generated by $here/setup; do not edit!\
ce178f96
MW
178
179/@releasekey@/ s::$(./mdw-conf release-key 481334C2):g
15581433 180/@gitignore@/ s::$(./mdw-conf gitignore $here/gitignore):g
ce178f96
MW
181" gitconfig >$HOME/.gitconfig.new
182mv $HOME/.gitconfig.new $HOME/.gitconfig
183echo " done."
184
185###--------------------------------------------------------------------------
186### Install useful scripts included in this package.
187
e04c4857 188scripts="
547fb8af 189 mdw-editor
b056f5c4 190 mdw-conf
8e08f814 191 movemail-hack
285a1386
MW
192 emerge-hack
193 lesspipe.sh
194 start-ssh-agent
4cdeb0d0
MW
195 svnwrap
196 hyperspec"
8e08f814 197[ "$xstuff" ] && scripts="$scripts
3bdada49 198 xinitcmd
8e08f814 199 xshutdown"
e04c4857
MW
200echo "Installing scripts..."
201mkdir -p $HOME$sub/bin
202for s in $scripts; do
203 ft=$HOME$sub/bin/$s
204 ln -s $here/$s $ft.new
205 mv $ft.new $ft
206 echo " $s"
207done
208echo " all done."
209
ce178f96
MW
210###--------------------------------------------------------------------------
211### Set up the Emacs config.
212
65ff0e8c
MW
213$echon "Finding a suitable emacs:$echoc"
214emacs=no
6960aa99 215for i in emacs22 emacs21 emacs; do
65ff0e8c
MW
216 if type -p >/dev/null $i; then
217 emacs=$i
218 break
219 fi
220done
221if [ $emacs = no ]; then
222 echo " failed."
223 emacs=:
224else
225 echo " $emacs."
226fi
227
f617db13 228echo "Installing Emacs packages..."
400223a1
MW
229emacspkg="
230 make-regexp
a1293ade 231 ew-hols
1778b496 232 git git-blame vc-git stgit
400223a1
MW
233 quilt"
234for elib in $emacspkg; do
f617db13 235 $echon " $elib:$echoc"
65ff0e8c 236 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 237 (progn
852cd5fb
MW
238 (setq load-path (nconc load-path (list "~/lib/emacs")))
239 (kill-emacs (condition-case nil
240 (progn (load-library "'"$elib"'") 0)
20eb0692 241 (error 1))))'; then
f617db13
MW
242 echo " already installed."
243 else
244 $echon " downloading$echoc"
20eb0692 245 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
f617db13
MW
246 $echon " compiling$echoc"
247 (cd $HOME$sub/lib/emacs;
65ff0e8c 248 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 249 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
250 echo " done."
251 fi
252done
852cd5fb 253echo " all done."
f617db13
MW
254
255$echon "Setting up Emacs configuration:$echoc"
256$echon " linking$echoc"
257for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
258 set -- $(echo $link | tr : ' ')
259 from=$1 to=$2
739bccbf
MW
260 ln -s $here/$from $HOME$sub/lib/emacs/$to.new
261 mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
f617db13
MW
262done
263$echon " compiling$echoc"
65ff0e8c 264make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
f617db13 265echo " done."
ce178f96
MW
266
267###----- That's all, folks --------------------------------------------------